#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/**/
#define	swap(a,b)(a ^= b, b ^= a, a ^= b)
/**/
/*EXTERNAL*/
/**/
static      struct  NUMREG  nr[NREGS];
/**/
static      int     ru;     /* number of registers in use */
/**/
xrr(nv,is)                   /* remove the named register */
char    *is;
{
	REG     struct  NUMREG  *nrx;
	REG     struct  NUMREG  *nry;
	if(!(nrx = regfind(is)))    return(-1);
	nry = nrx + 1;
	while(nry < &nr[ru])    {
		swap(nrx->vlu,nry->vlu);
		swap(nrx->nme[0],nry->nme[0]);
		swap(nrx->nme[1],nry->nme[1]);
		nrx += 1;
		nry += 1;
	}
	return(--ru);
}
xnr(nv,is)               /* create || set the named register */
char    *is;
{
	REG     struct  NUMREG  *nrx;
/**/
	if(!isalpha(is[0]) || !isalnum(is[1]))  {
		errmsg("xnr: <bad nr name>\n");
		terror(FUBAR);
		}
	nrx = regfind(is);
	if(nrx == NULL) {
		nrx = &nr[ru++];
		if(ru >= NREGS) {
			errmsg("xnr: <too many named registers>\n");
			terror(FUBAR);
			}
		nrx->vlu = 0;
		nrx->nme[0] = is[0];
		nrx->nme[1] = is[1];
		nrx = regsort();
		}
	while(isalnum(*is)) ++is;
	while(isspace(*is)) ++is;
	nrx->vlu = setvar(nv,is,ABSO,nrx->vlu,0);
	return(nrx->vlu);
}
struct  NUMREG  *
regsort()               /* keep register names sorted */
{
	REG     struct  NUMREG  *nrx = nr + ru - 1;
	REG     struct  NUMREG  *nry = nrx - 1;
	while(nrx > &nr[0]) {
		if(strncmp(nrx->nme,nry->nme,2) < 0){
			swap(nrx->nme[0],nry->nme[0]);
			swap(nrx->nme[1],nry->nme[1]);
			swap(nrx->vlu,nry->vlu);
			nrx -= 1;
			nry -= 1;
			}
		else    break;
	}
	return(nrx);
}
struct  NUMREG  *
regfind(is)
char    *is;
{
/*  CHANGE TO BINARY */
	REG struct  NUMREG  *nrx = nr;
	while(nrx < &nr[ru])    {
		if(nrx->nme[0] == is[0] &&
			nrx->nme[1] == is[1])   return(nrx);
		else                        ++nrx;
	}
	return(NULL);
}
