#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/**/
#ifndef		ZERO
#define		ZERO	0
#endif
/**/
#define		USE_STACK	/* work space from stack */
#undef		USE_STACK	/* work space from malloc */
/**/
#define     WTEXT       1
#define     WDIVR       2
#define     WTABL       4
#define	    LNOSZ       16	/* width of line numbers */
/**/
/*EXTERNAL*/
extern	char	*free_if();
/**/
xtxt(nv,is)         /* process text */
char    *is;
{
	auto    int     nr;
	if(x[nv].tr)        ztr(nv,is);
	if(x[nv].tf >= 1)   {
		nr = ztb(nv,is);
		if(nr)          return(nr);
		}
	if(x[nv].ce >= 1)   return(zce(nv,is));
	if(x[nv].fi >= 1)   return(filler(nv,is));
	if(x[nv].fi <= 0)   return(nofill(nv,is));
	dump("xtxt");
	return(FUBAR);
}
divwrt(nv,is)       /* used for output from diversion */
char    *is;
{
	return(writer(nv,is,WDIVR));
}
tblwrt(nv,is)       /* used for headers, tables, centering */
char    *is;
{
	return(writer(nv,is,WTABL));
}
txtwrt(nv,is)       /* used to write ordinary text */
char    *is;
{
	return(writer(nv,is,WTEXT));
}
writer(nv,is,ty)    /* low level write routine */
char    *is;
{
#ifdef	USE_STACK
	auto		char	ws[BLKSIZ];
	auto        char    *wsx = ws;
	auto        char    *wsu = ws + BLKSIZ -1;
#else	USE_STACK
	auto		int		ll = bufsiz();
	auto		char	*ws = emalloc(ll,"writer");
	auto		char	*wsx = ws;
	auto		char	*wsu = ws + ll - 1;
#endif	USE_STACK
	auto        int     ni;
/*
**  might modify this to use a fifo stack
*/
/*  calculate net indent */
	ni = x[nv].in + x[nv].ti;
/*  if line numbering is on, prepend line number */
	if(x[nv].nm)                wsx = znm(wsx,wsu,nv,ty);
/*  prepend indent */
	if(ty & WTABL)	ni = ZERO;
	if(ni) 	{
		*wsx++ = WORD;
		*wsx++ = (char) ni;
		*wsx++ = STOP;
		}
/*  move text to output string */
	wsx = strkat(wsx,wsu,is);
/*  work traps */
	while(trapat(nv,x[nv].vp))  ;
/*  if diversion, write raw, otherwise write terminal */
	if(x[nv].di)                fputs(ws,x[nv].ofp);
	else                        fputut(ws,x[nv].ofp,x[nv].po);
/*  append a line feed */
	putc('\n',x[nv].ofp);
/*WORK*/
/*  update the line, page numbers */
	linepage(nv,1);
/*  reset line parameters */
	if(ty & WTEXT)            			zrs(nv,is);
/*  do spacing */
	if(x[nv].ls > 1 && (ty & WTEXT))    zsp(nv,x[nv].ls-1);
/*  flush if debugging */
	if(db)                 				fflush(x[nv].ofp);
#ifdef	USE_STACK
#else	USE_STACK
	ws = free_if(ws);
#endif	USE_STACK
	return(0);
}
char	*
znm(os,us,nv,ty)            /* line number function */
char    *os, *us;
{
	char    ws[16];
	if(ty == WTEXT && nv <= 0)  sprintf(ws,"%-3d   ",x[nv].vp);
	else                        sprintf(ws,"%-6s","");
	return(strkat(os,us,ws));
}
xem(nv,is)                  /* set end macro */
char    *is;
{
	static  char    em[3];
	if(is == NULL)  spring(nv,em);
	else    {
			em[0] = is[0];
			em[1] = is[1];
			em[2] = ZERO;
		}
	return(ZERO);
}
