/*
WARNING:	enabling the trace function can induce other problems
			because of the use of strsave.
88:12:07	changed kloser to detect and abort on attempts to
			close a previously closed file.
*/
/*COMLIB*/
#define		WHATFILE
#undef		WHATFILE
#define		SAVENAME	/* record the name(s) of open file(s) */
#undef		SAVENAME
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*
	routines to process file pointers with error messages
	routines to track open and closed streams
*/
#define		NFILE		64
#define		TCLSD		0
#define		TPIPE		1
#define		TFILE		2
static	char	*ft[] = {
		"tclsd",
		"tpipe",
		"tfile",
	}	;
typedef	struct	FILE_TYPE	{
	FILE	*kfp;	/* file pointer */
	char	*kty;	/* type: pipe or file */
#ifdef	SAVENAME
	char	*nme;	/* file name */
#endif	/*SAVENAME*/
}	FILE_TYPE;
static	FILE_TYPE	kf[NFILE];
/*EXTERN*/
extern  KENV    kenv;
/**/
#ifdef	CAN_PROTO
static  int     kloser(FILE *);
static	int		savefile(FILE *, char *, NOSIGN, char *);
extern	void	exit(int);
#else
static  int     kloser();
static	int		savefile();
extern	void	exit();
#endif
/**/
static
savefile(fp,fn,ty,is)
FILE	*fp;	/* FILE pointer */
char	*fn;	/* file name */
NOSIGN	ty;		/* file type */
char	*is;	/* calling routine */
{
	auto	int		rfn = fileno(fp);
	if(rfn < 0)	{
		errmsg("savefile:%s <bad pointer> '%u\n",is,fp);
		exit(FUBAR);
		}
	if(rfn >= NFILE)	{
		errmsg("savefile:%s <absurd file number> '%u\n",is,rfn);
		exit(FUBAR);
		}
	kf[rfn].kty = ft[ty];
	kf[rfn].kfp = fp;
#ifdef	SAVENAME
	if(!(kf[rfn].nme = strsave(fn)))	{
		errmsg("savefile <no core>\n");
		terror(FUBAR);
		}
#endif	SAVENAME
#ifdef	WHATFILE
	whatfile("savefile");
#endif
	return(rfn);
}
#ifdef	WHATFILE
whatfile(is)
char	*is;
{
	auto	NOSIGN	ix;
	auto	NOSIGN	xn = 0;
	for(ix = 0; ix < NFILE; ix++)	{
		if(kf[ix].kty)	{
			fprintf(stderr,"%s ",is);
			fprintf(stderr,"%u ",ix);
			fprintf(stderr,"%s ",kf[ix].kty);
			fprintf(stderr,"%6u ",kf[ix].kfp);
			fprintf(stderr,"%s ",kf[ix].nme);
			fprintf(stderr,"\n");
			xn += 1;
			}
		}
	if(xn == 0)	{
		prwho(" <no files open> %s\n",is);
		}
	else
	if(query(stderr) == 'q')	exit(FUBAR);
	return(xn);
}
#else
whatfile()
{
}
#endif
FILE	*
epopen(fn,mo)
char	*fn;
char	*mo;
{
	auto	FILE	*rfp;
	rfp = popen(fn,mo);
	if(!rfp)	{
		prterr("%s",fn);
		return(NULL);
		}
	savefile(rfp,fn,TPIPE,"epopen");
	return(rfp);
}
FILE	*
tefopen(fn,mo)
char	*fn;
char	*mo;
{
	auto	FILE	*rfp;
	if(!(rfp = efopen(fn,mo)))	fubar(FUBAR);
#ifdef	WHATFILE
	whatfile("tefopen");
#endif
	return(rfp);
}
FILE	*
efopen(fn,mo)
char	*fn;
char	*mo;
{
	auto	FILE	*rfp;
	if(!(rfp = fopen(fn,mo)))	{
		prterr("%s",fn);
		}
	else	{
		savefile(rfp,fn,TFILE,"efopen");
		}
	return(rfp);
}
FILE	*
efclose(fp)		/* close _fp if it is open */
FILE	*fp;
{
#ifdef	WHATFILE
	whatfile("efclose");
#endif
	if(!fp)	{
		errmsg("efclose <NULL>\n");
		}
	else	{
		kloser(fp);
		}
	return( (FILE *) NULL );
}
void
efclean(fp)		/* close all open files except _fp */
FILE	*fp;
{
	auto	int		i;
	auto	int		n = ZERO;
/**/
/**/
	for(i = 0; i < NFILE; i++)	{
		if(kf[i].kfp && (kf[i].kfp != fp))	{
			kf[i].kfp = efclose(kf[i].kfp);
			n += 1;
			}
		}
/**/
	return;
}
FILE	*
xfclose(fp)		/* close _fp unless std* streams */
FILE	*fp;
{
#ifdef	WHATFILE
	whatfile("xfclose");
#endif
	if(fp != (FILE *) NULL)	{
		switch( fileno(fp) )	{
			case	0:	break;
			case	1:	break;
			case	2:	break;
			case	-1:	errmsg("xfclose <NULL>\n"); break;
			default:	fp = efclose(fp); break;
			}
	}
	return(fp);
}
static	int
kloser(fp)		/* make sure the right close command is used */
FILE	*fp;
{
	auto	int		rfn = fileno(fp);
	if(rfn < 0)	{
		errmsg("kloser <bad pointer> '%u'\n",fp);
		exit(FUBAR);
		}
#ifdef	WHATFILE
	whatfile("kloser");
#endif
/**/
	if(kf[rfn].kfp == (FILE *) NULL)	{
		errmsg(" kloser <close error> '%u'\n",rfn);
		}
	else	{
	fflush(kf[rfn].kfp);
/**/
	if(kf[rfn].kty == ft[TPIPE]) pclose(kf[rfn].kfp);
	else	
	if(kf[rfn].kty == ft[TFILE]) fclose(kf[rfn].kfp);
/**/
	kf[rfn].kfp = (FILE *) NULL;
	kf[rfn].kty = NULL;
#ifdef	SAVENAME
	kf[rfn].nme = free_if(kf[rfn].nme);
#endif	SAVENAME
		}
	return(rfn);
}
efseek(fp,ad,ty)	/* seek with error message */
FILE	*fp;
long	ad;
int		ty;
{
	auto	int		er;
	er = fseek(fp,ad,ty);
	if(er != 0)	prterr("efseek(%u,%ld,%u)",fp,ad,ty);
	return(er);
}
long
eftell(fp)		/* file position with error message */
FILE	*fp;
{
	auto	long	er = ftell(fp);
	if(er < 0L)		prterr("eftell(%u)",fp);
	return(er);
}
